%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CRAY-DATA-MACHINE.SL - Lisp item constructors & selectors for Cray
%
% Author:      M. L. Griss, S. Lowder, R. Kessler
%              Computer Science Dept.
%              University of Utah
% Date:        10 June 1982
% Copyright (c) 1982 University of Utah
%
% Copyright (c) 1987 , Konrad Zuse Zentrum Berlin , for modifications
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Added SYMGET macro, 20 Oct 1988, W. Neun
%  Converted to Standard-Lisp 2-Jan-86 ZIB Berlin
%  <PSL.COMP.CRAY>CRAY-DATA-MACHINE.RED.9,  6-Apr-83 09:23:36, Edit by KESSLER
%  Added GC guys.
%  <PSL.COMP.CRAY>CRAY-DATA-MACHINE.RED.6, 28-Mar-83 07:58:40, Edit by KESSLER
%  Changed obarray in data-machine to be full words.
 
% Primitives handled by the compiler are BYTE, PUTBYTE, GETMEM, PUTMEM,
% MKITEM, FIELD, SIGNEDFIELD, PUTFIELD
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% MACHINE DEPENDENT CONSTANTS FOR THE CRAY-1 (in SYSCONST !!)         %
% Four PARCELS per LONGWORD (64 bits).                                %
% Eight CHARACTERs per LONGWORD (64 bits).                            %
% Stack grows down, rather than UP, used to control Stack Scan loops. %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 
(dm GCField (U)
   `(Field ,(cadr U) (WConst GCStartingBit) (WConst GCBitLength)))
 
(dm PutGCField (U)
   `(PutField ,(cadr U) (WConst GCStartingBit) (WConst GCBitLength)
              ,(caddr U)))
 
% Retrieve the address stored in the function cell
 
(dm SymFnc (U)
   `(Wshift (WShift (WGetV SymFnc ,(cadr U)) 6) -40))
 
%%% (dm PutSymFnc (U)
%%%    (list 'WPutV '(WConst SymFnc) (cadr U)
%%%          ('WOr, list ('WShift, caddr U, 34), 16#0c00000048494849));
 
(dm SymCnt (U)
        `(wgetv SymCnt ,(cadr U)))
 
(dm Symget (U)
        `(wgetv Symget ,(cadr U)))
 
% Macros for building stack pointers, no-ops on the VAX
 
(dm MakeStackPointerFromAddress (U) (cadr u))
 
(dm MakeAddressFromStackPointer (U) (cadr U))
 
(RemProp 'AdjustStackPointer 'OpenFn)
 
(dm AdjustStackPointer (U)
    (cons 'WDifference (cdr U)))
 
% ObArray is outmoded!! (now hash-table-entry) here for compatibility
% ObArray is a linearly allocated hash table containing ID numbers of entries
% maintained as a circular buffer.  It is referenced only via these macros
% because we may decide to change to some other representation.
 
(ds ObArray (I)
 (halfword HashTable I))
 
(ds PutObArray (I X)
 (puthalfword HashTable I X))
 
(put 'ObArray 'Assign-Op 'PutObArray)
 
