%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXK:SYS-SUPPORT.SL
% Description:  alpha-specific kernel support functions
% Author:       Winfried Neun
% Created:      20-Jan-93
% Mode:         Lisp
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% ADDRESSAPPLY0 is defined as open code.

% BITTABLE is defined as open code.

(lap '((*entry PlantUnbound expr 1)
        (sll (reg 1) 3 (reg t2))
        (*WPLUS2 (reg t2) (fluid SYMFNC))
	(la  (reg t1) UndefinedFunctionInstruction) 
        (*move (displacement (reg t1) 0) (reg t3))
	(*move  (reg t3) (displacement (reg t2) 0))
        (*EXIT 0)
	(!.psect "pslmains,data")
    UndefinedFunctionInstruction
       (!.quad "undefinedfunction")))

(lap '( (*entry PlantCodePointer expr 2)
        (sll (reg 1) 3 (reg t2))
        (*WPLUS2 (reg t2) (fluid SYMFNC))
        (*move (reg 2) (displacement (reg t2) 0)) % and plant it
        (*EXIT 0)))

(lap '( (*entry PlantLambdaLink expr 1)
        (sll (reg 1) 3 (reg t2))
        (*WPLUS2 (reg t2) (fluid SYMFNC))
	(la (reg t1) LambdaLinkInstruction)
	(*move (displacement (reg t1) 0) (reg t1))
        (*move (reg t1) (displacement (reg t2) 0))
        (*EXIT 0)
        (!.psect "pslmains,data")
    LambdaLinkInstruction
       (!.quad "compiledcallinginterpreted")))

(lap '((*entry COMPILEDCALLINGINTERPRETED expr 0)
       (ldq (reg r27) (displacement (reg SYMFNCcenter)
		 (times2 8 (idloc COMPILEDCALLINGINTERPRETEDaux))))
       (jsr (reg null) (displacement (reg r27) nil))))
% call aux without destroying t3

(de bittable (baseaddress bitoffset)
  (field (ilsh (byte baseaddress (ilsh bitoffset -2))
               (idifference (itimes2 (field bitoffset 62 2) 2) 6))
         62 2))

(lap '((*entry undefinedfunction expr 1)
       (ldq (reg r27) (displacement (reg SYMFNCcenter)
		 (times2 8 (idloc undefinedfunctionaux))))
       (jsr (reg null) (displacement (reg r27) nil))))
% call aux without destroying t3

(lap '((*entry undefinedfunctionaux expr 1)
       (*alloc 1)
       (*move (reg t3) (frame 1))
       (*move (quote "Undefined function called: ") (reg 1))
       (*call console-print-string)
       (*move (frame 1) (reg 1))
       (*call unixputn)
       (*call console-newline)
       (*move (fluid symnam) (reg t2))
       (*move (frame 1) (reg t1))
       (*wshift (reg t1) 3)
       (*wplus2 (reg t1) (reg t2))
       (*move (displacement (reg t1) 0) (reg 1))
       (*call console-print-string)
       (*call console-newline)
       (*move 0 (reg 1))
       (*call Exit-with-status)
       (*exit 1)))

(de kernel-fatal-error (message)
  (console-print-string "FATAL ERROR:") 
  (console-print-string message)
  (console-newline)
  (exit-to-caller -1)
  )

(de exit-to-caller (sta)
   (external_exit sta))

(de WQuotient (x y)
    (if (eq y 0) (error 4713 "Zero Divide")
        (cquotient x y)))

(de WRemainder (x y)
    (if (eq y 0) (error 4713 "Zero Divide")
	(cremainder x y)))

(lap '((*entry signalhandler expr 3)
%
% No alloc, trap handler will never come back!
         (*jcall signal-done)
))


