%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXK:SYS-SUPPORT.SL
% Description:  i860-specific kernel support functions
% Author:       Winfried Neun
% Created:      10-May-92
% Mode:         Lisp
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% ADDRESSAPPLY0 is defined as open code.

% BITTABLE is defined as open code.

(lap '((*entry PlantUnbound expr 1)
        (shl 2 (reg 1) (reg t2))
        (*WPLUS2 (reg t2) (fluid SYMFNC))
	(orh (hi UndefinedFunctionInstruction) (reg 0) (reg t1))
	(ld!.l (displacement (reg t1) (low UndefinedFunctionInstruction))
		 (reg t1))
        (*move (reg t1) (displacement (reg t2) 0))
        (*EXIT 0)
    UndefinedFunctionInstruction
       (!.long "UNDEFINEDFUNCTION")))

(lap '( (*entry PlantCodePointer expr 2)
        (shl 2 (reg 1) (reg t2))
        (*WPLUS2 (reg t2) (fluid SYMFNC))
        (*move (reg 2) (displacement (reg t2) 0)) % and plant it
        (*EXIT 0)))

(lap '( (*entry PlantLambdaLink expr 1)
        (shl 2 (reg 1) (reg t2))
        (*WPLUS2 (reg t2) (fluid SYMFNC))
	(orh (hi LambdaLinkInstruction) (reg 0) (reg t1))
        (ld!.l (displacement (reg t1) (low LambdaLinkInstruction)) (reg t1))
        (*move (reg t1) (displacement (reg t2) 0))
        (*EXIT 0)
    LambdaLinkInstruction
       (!.long "COMPILEDCALLINGINTERPRETED")))

(lap '((*entry COMPILEDCALLINGINTERPRETED expr 0)
       (ld!.l (displacement (reg SYMFNCcenter)
		 (times2 4 (idloc COMPILEDCALLINGINTERPRETEDaux)))
		(reg t4))
       (bri (reg t4)) % call aux without destroying t3
       (or (reg 0) (reg 0) (reg 0))))

(de bittable (baseaddress bitoffset)
  (field (ilsh (byte baseaddress (ilsh bitoffset -2))
               (idifference (itimes2 (field bitoffset 30 2) 2) 6))
         30 2))

(lap '((*entry undefinedfunction expr 1)
       (ld!.l (displacement (reg SYMFNCcenter)
		 (times2 4 (idloc undefinedfunctionaux))) (reg t4))
       (bri (reg t4)) % call aux without destroying t3
	(or (reg 0) (reg 0) (reg 0))))
(lap '((*entry undefinedfunctionaux expr 1)
       (*alloc 1)
       (*move (reg t3) (frame 1))
       (*move (quote "Undefined function called: ") (reg 1))
       (*call console-print-string)
       (*move (frame 1) (reg t1))
       (*wshift (reg t1) 2)
       (*wplus2 (reg t1) (fluid symnam))
       (*move (displacement (reg t1) 0) (reg 1))
       (*call console-print-string)
       (*move 0 (reg 1))
       (*call Exit-with-status)
       (*exit 1)))

(de kernel-fatal-error (message)
  (console-print-string "FATAL ERROR:") 
  (console-print-string message)
  (console-newline)
  (exit-to-caller -1)
  )

(de exit-to-caller (sta)
   (external_exit sta))

% The following arithmetic codes are typed from i860 programmers ref man
% part 12

(compiletime (flag '(signed_integer_divide) 'internalfunction))

(lap '((*entry  signed_integer_divide expr 2)
	(orh (hi two52two31) (reg 0) (reg t1))
	(fld!.d (displacement (reg t1) (low two52two31)) (reg f6))
	(xorh  16#8000 (reg 1) (reg t1))
	(ixfr (reg t1) (reg f4))
	(fmov!.ss (reg f7) (reg f5))
	(xorh 16#8000 (reg 2) (reg t3))
	(fsub!.dd (reg f4) (reg f6) (reg f4))
	(ixfr (reg t3) (reg f2))
	(fmov!.ss (reg f7) (reg f3))
	(fsub!.dd (reg f2) (reg f6) (reg f2))
	(orh (hi dbltwo) (reg 0) (reg t1))
	(fld!.d (displacement (reg t1) (low dbltwo)) (reg f10))
	(frcp!.dd (reg f4) (reg f6))
	(fmul!.dd (reg f4) (reg f6) (reg f8))
	(fsub!.dd (reg f10) (reg f8) (reg f8))
	(fmul!.dd (reg f6) (reg f8) (reg f6))
	(fmul!.dd (reg f4) (reg f6) (reg f8))
	(fsub!.dd (reg f10) (reg f8) (reg f8))
	(fmul!.dd (reg f6) (reg f8) (reg f6))
	(fmul!.dd (reg f4) (reg f6) (reg f8))
	(fsub!.dd (reg f10) (reg f8) (reg f8))
	(fmul!.dd (reg f6) (reg f2) (reg f6))
	(fmul!.dd (reg f8) (reg f6) (reg f8))
	(orh (hi onepluseps) (reg 0) (reg t1))
        (fld!.d (displacement (reg t1) (low onepluseps)) (reg f10))
	(fmul!.dd (reg f8) (reg f10) (reg f8))
	(ixfr (reg 1) (reg f10))
	(ftrunc!.dd (reg f8) (reg f8))
% quotient is done , remainder follows
	(fmlow!.dd (reg f10) (reg f8) (reg f10))
	(fxfr (reg f10) (reg 1))
	(fxfr (reg f8) (reg 3))        % this is the quotient
	(subs (reg 2) (reg 1) (reg 4)) % this is the remainder
        (*exit 0)
	(!.align 8)
     two52two31
	(!.double "2^52+2^31")
     onepluseps
	(!.double "1+2^-40")
     dbltwo
	(!.double "2.0")))

(de WQuotient (x y)
    (if (eq y 0) (error 4713 "Zero Divide")
        (cquotient x y)))

(lap '((*entry WWQuotient expr 2)
       (*alloc 1)
       (*move  (reg 1) (reg 3))
       (*move  (reg 2) (reg 1))
       (*move (reg 3)  (reg 2))
       (*call signed_integer_divide)
       (*move (reg 3) (reg 1))
       (*exit 1)))

(de WRemainder (x y)
    (if (eq y 0) (error 4713 "Zero Divide")
	(cremainder x y)))

(lap '((*entry WWRemainder expr 2)
	(*alloc 1)
       (*move  (reg 1) (reg 3))
       (*move  (reg 2) (reg 1))
       (*move (reg 3)  (reg 2))
	(*call signed_integer_divide)
	(*move (reg 4) (reg 1))
	(*exit 1)))
 
(lap '((*entry WTimes2 expr 2)
       (*alloc 0)
       (ixfr (reg 1) (reg f2))
       (ixfr (reg 2) (reg f4))
       (fmlow!.dd (reg f4) (reg f2) (reg f6))
       (fxfr (reg f6) (reg 1))
       (*exit 0)))

(lap '((*entry wtimesdou expr 2)
	(*alloc 10)
	(ixfr (reg 1) (reg f2))
	(ixfr (reg 0) (reg f3))
	(ixfr (reg 0) (reg f5))
	(ixfr (reg 0) (reg f7))
	(ixfr (reg 0) (reg f9))
	(ixfr (reg 0) (reg f11))
	(*move (reg 2) (reg 3))
	(*wshift (reg 2) -16)
	(*wand (reg 3) 16#ffff)
	(ixfr (reg 2) (reg f4))
	(ixfr (reg 3) (reg f6))
	(fmlow!.dd (reg f4) (reg f2) (reg f8))
	(fmlow!.dd (reg f6) (reg f2) (reg f10))
	(fst!.d (reg f8) (displacement (reg st) 16))
	(fst!.d (reg f10) (displacement (reg st) 24))
	(*move  (displacement (reg st) 20) (reg 1))
	(*move  (displacement (reg st) 28) (reg 2))
	(*wshift (reg 1) 16)
	(*move  (displacement (reg st) 16) (reg 3))
	(*wand (reg 2) 16#ffff)
	(*wshift (reg 3) -16)
	(*wor (reg 1) (reg 2))
	(*wplus2 (reg 1) (reg 3))
	(*move  (displacement (reg st) 16) (reg 3))
	(*move  (displacement (reg st) 24) (reg 5))	
	(*wand (reg 3) 16#ffff)
	(*move (reg 5) (reg 2))
	(*wshift (reg 2) -16)
	(*wplus2 (reg 2) (reg 3))
	(*move (reg 2) (reg 4))
	(*wshift (reg 4) -16) % a carry?
	(*wplus2 (reg 4) (reg 1))
        (*move (reg 4)  ($fluid *second-value*))
	(*wand  (reg 5) 16#ffff)
	(*wshift (reg 2) 16)
	(or (reg 5) (reg 2) (reg 1))
	(*exit 10)))

(lap '((*entry signalhandler expr 3)
%
% No alloc, trap handler will never come back!
%
         (*move ($fluid SYMFNC) (reg r7))
	 (*move ($fluid SYMval) (reg r8))
	 (*move 128 (reg nil))
	 (*mkitem (reg nil) id-tag)
         (*movex (reg 1) (fluid i860-signumber))
         (*movex (reg 2) (fluid i860-sigcode))
         (*movex (reg 3) (fluid i860-sigcp))   % save signal context
         (*move (indexed (reg 3) 16) (reg 4))
         (*movex (reg 4) (fluid i860-sigpc))

%  Check whether LISP trap handling is appropriate now

         (*movex ($fluid *kernelmode) (reg 5))
         (*jumpnoteq (label goon) (reg 5) 'nil)
         (*jumpnoteq (label templab) (reg 1) (quote 2)) % interrupt
         (*movex ($fluid *bruch*) (reg 5))
         (*jumpeq    (label templab) (reg 5) 0)

    goon
         (*move -17 (reg 5))
         (*movex (reg 5) ($fluid *bruch*))
         (*move 0 (reg 5))
         (*movex (reg 5) (fluid i860-sigcp))
         (bri (reg returnaddr))
         (nop)

    templab
         (*jcall signal-done)))
(commentoutcode
         (*movex ($fluid i860-sigcp) (reg t1))
         (*movex ($fluid i860-dumparray*) (reg t2))
         (*wshift (reg t2) 2)
         (*move 77 (reg t4))
      lab
         (*move (indexed (reg t1) 0) (reg t5))
         (*move (reg t5) (indexed (reg t2) 0))
         (*wplus2 (reg t1) 4)
         (*wplus2 (reg t2) 4)
         (*wplus2 (reg t4) -1)
         (*jumpwgreaterp (label lab) (reg t4) 0)

         (*movex  ($fluid i860-sigpc) (reg t4))
         (*wshift (reg t4) 2)
         (*move (indexed (reg t4) 0) (reg t4))
         (*move 2#10101111101 (reg t5))
         (*wshift (reg t4) -21)
         (*jumpeq (label nodump) (reg t4) (reg t5))
         (*move 50 (reg t4))
         (*movex ($fluid i860-dumparray*) (reg t1))
         (*wshift (reg t1) 2)

         (*move (indexed (reg t1) 128) (reg t1))
         (*wdifference (reg t1) 40)
     stack-lab                % copy a centerdump of stack
         (*move (indexed (reg t1) 0) (reg t5))
         (*move (reg t5) (indexed (reg t2) 0))
         (*wplus2 (reg t1) 4)
         (*wplus2 (reg t2) 4)
         (*wplus2 (reg t4) -1)
         (*jumpwgreaterp (label stack-lab) (reg t4) 0)

     nodump
         (*jcall signal-done)
))


