%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:           PXNK:APPLY-LAP.SL
% Title:          LAP support for EVAL and APPLY  (Hacked version for testing)
% Author:         Eric Benson
% Created:        20 August 1981
% Modified:       26 Jan 1984 1040-PST (Brian Beach)
% Status:         Experimental
% Mode:           Lisp
% Package:        Kernel
%
% (c) Copyright 1983, Hewlett-Packard Company, all rights reserved.
% (c) Copyright 1981, University of Utah
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 01-Sep-88 (Julian Padget)
%  Bnd... declarations changed from fluid to global.
% 26 Jan 1984 1036-PST (Brian Beach)
%  Corrected file name in header.
% 2-Dec-83  16:00:00 (Brian Beach)
%   Translated from Rlisp to Lisp.
% Griss and Perdue, 10 January 1983
%	Modified Undefined function to make compiled calls
%	continuable
%
% may 23-1988 chris burdorf and T. Yamamoto
%   modified for sparc, got rid of vax specific code in casel, extv, 
%   autoincrement, and divl
%
% July 20,1988 T. Yamamoto: inline coding of argument distribution.
% November15 1988 W. Neun, removed move and *move (frame  ) cmacros
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(global '(bndstkptr bndstkupperbound))

(compiletime (load sys-macros))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% if this could be written in Syslisp, it would look something like this:
%
% syslsp procedure CodeApply(CodePtr, ArgList);
% begin scalar N;
%     N := 0;
%     while PairP ArgList do
%     <<  N := N + 1;
%	  ArgumentRegister[N] := car ArgList;
%	  ArgList := cdr ArgList >>;
%     (jump to address of code pointer)
% end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(lap '((*entry codeapply expr 2)
       %
       % CodeApply(CodePointer, ArgList)
       %
       % (reg 1) is code pointer
       % (reg 2) is arg list
       %
       (*alloc 0)
       (*field (reg t1) (reg argone) 5 27)	% (reg t1) <- entry point.
       (*move (reg argtwo) (reg t2))		% (reg t2) <- arglist

       (*jumpeq (label CONTINUE) (reg t2) (reg nil))	% 0 argument

       (*move (car (reg t2)) (reg 1))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 2))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 3))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 4))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 5))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 6))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 7))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 8))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 9))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 10))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 11))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 12))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 13))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 14))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 15))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (car (reg t2)) (reg 16))
       (*move (cdr (reg t2)) (reg t2))
       (*jumpeq (label CONTINUE) (reg t2) (reg nil))

       (*move (quote "Too many arguments to function") (reg 1))
       (*dealloc 0)
       (*jcall stderror)
       
CONTINUE
       (*dealloc 0)
       (jmpl (deferred (reg t1)) (reg 0))
       (nop)))
       

(de codeevalapply (codeptr arglist)
  (codeapply codeptr (evlis arglist)))

(de bindeval (formals args)
  (bindevalaux formals args 0))

(de bindevalaux (formals args n)
  (let (f
        a)
       (cond ((pairp formals) (if (pairp args)
                (progn (setq f (first formals))
                       (setq a (eval (first args)))
                       (setq n
                        (bindevalaux (rest formals) (rest args) (iadd1 n)))
                       (if (weq n -1)
                         -1
                         (progn (lbind1 f a)
                                n)))
                -1))
             ((pairp args) -1)
             (t n))))


(lap '((*entry xxxfastapply expr 0)

       % Apply with arguments loaded
       %
       % Cadded with arguments in the registers and functional form in t1.

       (*move ($fluid *second-value*) (reg t1))
       (*field (reg t2)                    % Tag of function into T2
	       (reg t1)
	       (wconst tagstartingbit)
               (wconst tagbitlength))
       (*field (reg t1)                    % Inf of function into T1
	       (reg t1) 
	       (wconst infstartingbit)
               (wconst infbitlength))

       (*jumpnoteq (label notanid) (reg t2) (wconst id-tag))

       % ID: Link through function cell
       (*wshift (reg t1) 3) % multiply by addressingunitsperfunctioncell
       (*wplus2  (reg t1) (fluid symfnc))
       (jmpl (displacement (reg t1) 0) (reg 0))

NOTANID(*jumpnoteq (label notacodepointer) (reg t2) (wconst code-tag))

       % Code pointer: jump direct
        (jmpl (displacement (reg t1) 0) (reg 0))

NOTACODEPOINTER
       (*jumpnoteq (label illegalfunctionalform) (reg t2) (wconst pair-tag))

       % Pair: make sure it's a lambda, then call FASTLAMBDAPPLY.

       (*move (memory (reg t1) (wconst 0)) (reg t2)) % CAR of the inf field.
       (*jumpnoteq (label illegalfunctionalform) (reg t2) 'lambda)

       (*jcall fastlambdaapply)		% (reg t1) <- lambda function

ILLEGALFUNCTIONALFORM
       (*move '"Illegal functional form in Apply" (reg 1))
       (*move (reg t1) (reg 2))
       (*call list2)
       (*jcall stderror)))

(lap '((*entry undefinedfunction expr 0)
       %
       % Error handler for non-code.
       %
       %	call SYMFNC+X		;; This function is undefined.
       %	.............
       % SYMFNC+X:
       %	call UNDEFINEDFUNCTION
       %	sethi o0,number         id number is shifted 10 bits
       %
       %
       % (reg t1) <- offset of symfnc table
       %
       (*alloc 17)
       (*move (reg i0) (frame 1))   % Set continueable address
                                   % o0 is i0 now!
       (*move (reg 1)(frame 2))
                                % Save all the regs (including fakes) (args)
       (*move (reg 2)(frame 3))
       (*move (reg 3)(frame 4))
       (*move (reg 4)(frame 5))
       (*move (reg 5)(frame 6))
       (*move (reg 6)(frame 7))
       (*move (reg 7)(frame 8))
       (*move (reg 8)(frame 9))
       (*move (reg 9)(frame 10))
       (*move (reg 10)(frame 11))
       (*move (reg 11)(frame 12))
       (*move (reg 12)(frame 13))
       (*move (reg 13)(frame 14))
       (*move (reg 14)(frame 15))
       (*move (reg 15)(frame 16))
       (*move (reg 16)(frame 17))

       (*wshift (frame 1) -10)
       (*move (frame 1) (reg 2))
       (*mkitem (reg 2) (wconst id-tag))
       (*move (reg 2) (frame 1))
       (*move '"Undefined function %r called from compiled code" (reg 1))
       (*call bldmsg)
       (*move (reg 1) (reg 2))
       (*move (wconst 0) (reg 1))
       (*move (reg nil) (reg 3))
       (*call continuableerror)

       (*move (frame 17 ) (reg 16))  
                          % Restore all those possible arguments
       (*move (frame 16 ) (reg 15))
       (*move (frame 15 ) (reg 14))
       (*move (frame 14 ) (reg 13))
       (*move (frame 13 ) (reg 12))
       (*move (frame 12 ) (reg 11))
       (*move (frame 11 ) (reg 10))
       (*move (frame 10 ) (reg 9))
       (*move (frame 9 ) (reg 8))
       (*move (frame 8 ) (reg 7))
       (*move (frame 7 ) (reg 6))
       (*move (frame 6 ) (reg 5))
       (*move (frame 5 ) (reg 4))
       (*move (frame 4 ) (reg 3))
       (*move (frame 3 ) (reg 2))
       (*move (frame 2 ) (reg 1))
       (*move (frame 1) (reg t1))
       (*move (frame 1) ($fluid *second-value*))
       (*linke 17 fastapply)))

%
% This is pretty gross, but it is essentially the same as LambdaApply, taking
% values from the argument registers instead of a list.
% if this could be written in Syslisp, it would look something like this:
%
% syslsp procedure CompiledCallingInterpreted IDOfFunction;
% begin scalar LForm, LArgs, N, Result;
%     LForm := get(IDOfFunction, '!*LambdaLink);
%     LArgs := cadr LForm;
%     LForm := cddr LForm;
%     N := 1;
%     while PairP LArgs do
%     <<  LBind1(car LArgs, ArgumentRegister[N];
%         LArgs := cdr LArgs;
%         N := N + 1 >>;
%     Result := EvProgN LForm;
%     UnBindN(N - 1);
%     return Result;
% end;

(lap '((*entry compiledcallinginterpreted expr 0) 
       % link for lambda
       %
       % called by 
       %
       %	call SYMFNC+Y
       %
       % SYMFNC+Y:
       %	call COMPILEDCALLINGINTERPRETED
       %	sethi %o0,number                  (shifted by 10 bits)
       %
       %%%%%(*move (reg o0) (reg t1))     % o0 = t1 for a leaf routine
       (srl (reg t1) 10 (reg t1))         % the id number
       (*move (reg t1) (reg t2))
       (*mkitem (reg t2) (wconst btr-tag))        % make stack mark for btrace
%%%%%  (*move (reg t2))

       (*wshift (reg t1) 2) %multiply by addressingunitsperitem 
			    % use wshift to avoid side effects.
			    % Offset into SYMPRP
       (*wplus2  (reg t1) ($fluid symprp))         % Prop list address
       (*move (memory (reg t1) (wconst 0))        % Property list
	      (reg t1))
LOOPFINDPROP
       (*jumpnottype (label propnotfound) (reg t1) pair-tag)
                                           % make sure prop list is a pair
       (*move (car (reg t1)) (reg t2))     % get car of prop list
       (*move (cdr (reg t1)) (reg t1))     % cdr down
       (*jumpnottype (label LOOPFINDPROP) (reg t2)  pair-tag)
       (*move (car (reg t2)) (reg t3))     % yes, look at car
       (*move (quote *lambdalink) (reg t4))
       (*jumpnoteq (label loopfindprop) (reg t3) (reg t4))
       (*move (cdr (reg t2)) (reg t1))     % yes, get lambda form
       (*jcall fastlambdaapply)
%
%	At this point, (reg t1) <- lambda function to be called.
%
(*entry fastapply expr 0)
 
       % Apply with arguments loaded
       %
       % Cadded with arguments in the registers and functional form in t1.
 
       (*move ($fluid *second-value*) (reg t1))
       (*field (reg t2)                    % Tag of function into T2
               (reg t1)
               (wconst tagstartingbit)
               (wconst tagbitlength))
       (*field (reg t1)                    % Inf of function into T1
               (reg t1) 
               (wconst infstartingbit)
               (wconst infbitlength))
 
       (*jumpnoteq (label notanid) (reg t2) (wconst id-tag))
 
       % ID: Link through function cell
       (*wshift (reg t1) 3) % multiply by addressingunitsperfunctioncell
       (*wplus2  (reg t1) (fluid symfnc))
       (jmpl (displacement (reg t1) 0) (reg 0))
 
NOTANID(*jumpnoteq (label notacodepointer) (reg t2) (wconst code-tag))
 
       % Code pointer: jump direct
        (jmpl (displacement (reg t1) 0) (reg 0))

NOTACODEPOINTER
       (*jumpnoteq (label illegalfunctionalform) (reg t2) (wconst pair-tag))
 
       % Pair: make sure it's a lambda, then call FASTLAMBDAPPLY.
 
       (*move (memory (reg t1) (wconst 0)) (reg t2)) % CAR of the inf field.
       (*jumpnoteq (label illegalfunctionalform) (reg t2) 'lambda)
 
       (*jcall fastlambdaapply)         % (reg t1) <- lambda function
 
ILLEGALFUNCTIONALFORM
       (*move '"Illegal functional form in Apply" (reg 1))
       (*move (reg t1) (reg 2))
       (*call list2)
       (*jcall stderror)

(*entry fastlambdaapply expr 0)		   % called from FastApply
        (*move (reg t1) ($fluid *second-value*))
        (*alloc 6)
        (*move  ($fluid *second-value*) (frame 2))

        (*move (cdr (frame 2)) (frame 2))     % get (cdr of lambda form
        (*move (cdr (frame 2)) (frame 1))     % save cddr in (reg t1)
        (*move (car (frame 2)) (frame 2))     % cadr of lambda form == arg list
					   % in (reg t2)
        (*move (fluid bndstkupperbound) (frame 3))
					   % binding stack limit.
        (*move (fluid bndstkptr) (frame 4))  % binding stack pointer in (reg t4)
        (*move (fluid bndstkptr) (frame 6))  % plus a copy for restoring
%
%	The first argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg argone) (memory (frame 5) (wconst 0)))
%
%	The second argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg argtwo) (memory (frame 5) (wconst 0)))
%
%	The third argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg argthree) (memory (frame 5) (wconst 0)))
%
%	The fourth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg argfour) (memory (frame 5) (wconst 0)))
%
%	The fifth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg argfive) (memory (frame 5) (wconst 0)))
%
%	The sixth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 6) (memory (frame 5) (wconst 0)))
%
%	The seventh argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 7) (memory (frame 5) (wconst 0)))
%
%	The eighth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 8) (memory (frame 5) (wconst 0)))
%
%	The nineth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 9) (memory (frame 5) (wconst 0)))
%
%	The tenth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 10) (memory (frame 5) (wconst 0)))
%
%	The eleventh argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 11) (memory (frame 5) (wconst 0)))
%
%	The twelveth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 12) (memory (frame 5) (wconst 0)))
%
%	The thirteenth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 13) (memory (frame 5) (wconst 0)))
%
%	The fourteenth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 14) (memory (frame 5) (wconst 0)))
%
%	The fifteenth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 15) (memory (frame 5) (wconst 0)))
%
%	The sixteenth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 16) (memory (frame 5) (wconst 0)))

        (*move '"Too many arguments to function" (reg 1))
        (*dealloc 6)
        (*jcall stderror)

BINDINGOVERFLOW
        (*dealloc 6)
        (*jcall bstackoverflow)             % then error

DONEBINDINGFORMALS
        (*move (frame 4) (fluid bndstkptr))  % store binding stack
        (*move (frame 1) (reg 1))            % get cddr of lambda form to eval
        (*call evprogn)                      % implicit progn
        (*move (reg 1) (frame 1))            % save result, get old bind stk ptr
        (*move (frame 6) (reg 1))
        (*call restoreenvironment)
        (*move (frame 1) (reg 1))
        (*exit 6)                            % and return

PROPNOTFOUND
        (*move '"*LAMBDALINK property not found for interpreted function"
               (reg 1))
        (*dealloc 6)
        (*jcall stderror)
(*entry xxxxfastlambdaapply expr 0)		   % called from FastApply
       (*move (reg t1) (reg t2))

       (*move (cdr (reg t2)) (reg t2))     % get cdr of lambda form
       (*move (cdr (reg t2)) (reg t1))     % save cddr in (reg t1)
       (*move (car (reg t2)) (reg t2))     % cadr of lambda form == arg list
					   % in (reg t2)
       (*move (fluid bndstkupperbound) (reg t3))
					   % binding stack limit.
       (*move (fluid bndstkptr) (reg t4))  % binding stack pointer in (reg t4)
 %     (*move (reg t4))                    % save it on the stack
%
%	The first argument
%
       (*jumpnottype (label DONEBINDINGFORMALS) (reg t2) pair-tag)
       (*wplus2 (reg t4) (wconst 8))
       (*jumpwgeq (label BINDINGOVERFLOW) (reg t4) (reg t3))
       (*move (car (reg t2)) (reg t5))
       (*move (cdr (reg t2)) (reg t2))
       (*field (reg t5) (reg t5) 5 27)	% (reg t5) <- id number
       (*move (reg t5) (memory (reg t4) (wconst -4)))
       (*wshift (reg t5) 2)
       (*wplus2 (reg t5) (fluid symval))
       (*move (memory (reg t5) (wconst 0)) (memory (reg t4) (wconst 0)))
       (*move (reg argone) (memory (reg t5) (wconst 0)))
%
%	The second argument
%
       (*jumpnottype (label DONEBINDINGFORMALS) (reg t2) pair-tag)
       (*wplus2 (reg t4) (wconst 8))
       (*jumpwgeq (label BINDINGOVERFLOW) (reg t4) (reg t3))
       (*move (car (reg t2)) (reg t5))
       (*move (cdr (reg t2)) (reg t2))
       (*field (reg t5) (reg t5) 5 27)	% (reg t5) <- id number
       (*move (reg t5) (memory (reg t4) (wconst -4)))
       (*wshift (reg t5) 2)
       (*wplus2 (reg t5) (fluid symval))
       (*move (memory (reg t5) (wconst 0)) (memory (reg t4) (wconst 0)))
       (*move (reg argtwo) (memory (reg t5) (wconst 0)))
%
%	The third argument
%
       (*jumpnottype (label DONEBINDINGFORMALS) (reg t2) pair-tag)
       (*wplus2 (reg t4) (wconst 8))
       (*jumpwgeq (label BINDINGOVERFLOW) (reg t4) (reg t3))
       (*move (car (reg t2)) (reg t5))
       (*move (cdr (reg t2)) (reg t2))
       (*field (reg t5) (reg t5) 5 27)	% (reg t5) <- id number
       (*move (reg t5) (memory (reg t4) (wconst -4)))
       (*wshift (reg t5) 2)
       (*wplus2 (reg t5) (fluid symval))
       (*move (memory (reg t5) (wconst 0)) (memory (reg t4) (wconst 0)))
       (*move (reg argthree) (memory (reg t5) (wconst 0)))
%
%	The fourth argument
%
       (*jumpnottype (label DONEBINDINGFORMALS) (reg t2) pair-tag)
       (*wplus2 (reg t4) (wconst 8))
       (*jumpwgeq (label BINDINGOVERFLOW) (reg t4) (reg t3))
       (*move (car (reg t2)) (reg t5))
       (*move (cdr (reg t2)) (reg t2))
       (*field (reg t5) (reg t5) 5 27)	% (reg t5) <- id number
       (*move (reg t5) (memory (reg t4) (wconst -4)))
       (*wshift (reg t5) 2)
       (*wplus2 (reg t5) (fluid symval))
       (*move (memory (reg t5) (wconst 0)) (memory (reg t4) (wconst 0)))
       (*move (reg argfour) (memory (reg t5) (wconst 0)))
%
%	The fifth argument
%
       (*jumpnottype (label DONEBINDINGFORMALS) (reg t2) pair-tag)
       (*wplus2 (reg t4) (wconst 8))
       (*jumpwgeq (label BINDINGOVERFLOW) (reg t4) (reg t3))
       (*move (car (reg t2)) (reg t5))
       (*move (cdr (reg t2)) (reg t2))
       (*field (reg t5) (reg t5) 5 27)	% (reg t5) <- id number
       (*move (reg t5) (memory (reg t4) (wconst -4)))
       (*wshift (reg t5) 2)
       (*wplus2 (reg t5) (fluid symval))
       (*move (memory (reg t5) (wconst 0)) (memory (reg t4) (wconst 0)))
       (*move (reg argfive) (memory (reg t5) (wconst 0)))
%
%	The sixth argument
%
       (*jumpnottype (label DONEBINDINGFORMALS) (reg t2) pair-tag)
       (*wplus2 (reg t4) (wconst 8))
       (*jumpwgeq (label BINDINGOVERFLOW) (reg t4) (reg t3))
       (*move (car (reg t2)) (reg t5))
       (*move (cdr (reg t2)) (reg t2))
       (*field (reg t5) (reg t5) 5 27)	% (reg t5) <- id number
       (*move (reg t5) (memory (reg t4) (wconst -4)))
       (*wshift (reg t5) 2)
       (*wplus2 (reg t5) (fluid symval))
       (*move (memory (reg t5) (wconst 0)) (memory (reg t4) (wconst 0)))
       (*move (reg 6) (memory (reg t5) (wconst 0)))
%
%	The seventh argument
%
       (*jumpnottype (label DONEBINDINGFORMALS) (reg t2) pair-tag)
       (*wplus2 (reg t4) (wconst 8))
       (*jumpwgeq (label BINDINGOVERFLOW) (reg t4) (reg t3))
       (*move (car (reg t2)) (reg t5))
       (*move (cdr (reg t2)) (reg t2))
       (*field (reg t5) (reg t5) 5 27)	% (reg t5) <- id number
       (*move (reg t5) (memory (reg t4) (wconst -4)))
       (*wshift (reg t5) 2)
       (*wplus2 (reg t5) (fluid symval))
       (*move (memory (reg t5) (wconst 0)) (memory (reg t4) (wconst 0)))
       (*move (reg 7) (memory (reg t5) (wconst 0)))
%
%	The eighth argument
%
       (*jumpnottype (label DONEBINDINGFORMALS) (reg t2) pair-tag)
       (*wplus2 (reg t4) (wconst 8))
       (*jumpwgeq (label BINDINGOVERFLOW) (reg t4) (reg t3))
       (*move (car (reg t2)) (reg t5))
       (*move (cdr (reg t2)) (reg t2))
       (*field (reg t5) (reg t5) 5 27)	% (reg t5) <- id number
       (*move (reg t5) (memory (reg t4) (wconst -4)))
       (*wshift (reg t5) 2)
       (*wplus2 (reg t5) (fluid symval))
       (*move (memory (reg t5) (wconst 0)) (memory (reg t4) (wconst 0)))
       (*move (reg 8) (memory (reg t5) (wconst 0)))
%
%	The nineth argument
%
       (*jumpnottype (label DONEBINDINGFORMALS) (reg t2) pair-tag)
       (*wplus2 (reg t4) (wconst 8))
       (*jumpwgeq (label BINDINGOVERFLOW) (reg t4) (reg t3))
       (*move (car (reg t2)) (reg t5))
       (*move (cdr (reg t2)) (reg t2))
       (*field (reg t5) (reg t5) 5 27)	% (reg t5) <- id number
       (*move (reg t5) (memory (reg t4) (wconst -4)))
       (*wshift (reg t5) 2)
       (*wplus2 (reg t5) (fluid symval))
       (*move (memory (reg t5) (wconst 0)) (memory (reg t4) (wconst 0)))
       (*move (reg 9) (memory (reg t5) (wconst 0)))
%
%	The tenth argument
%
       (*jumpnottype (label DONEBINDINGFORMALS) (reg t2) pair-tag)
       (*wplus2 (reg t4) (wconst 8))
       (*jumpwgeq (label BINDINGOVERFLOW) (reg t4) (reg t3))
       (*move (car (reg t2)) (reg t5))
       (*move (cdr (reg t2)) (reg t2))
       (*field (reg t5) (reg t5) 5 27)	% (reg t5) <- id number
       (*move (reg t5) (memory (reg t4) (wconst -4)))
       (*wshift (reg t5) 2)
       (*wplus2 (reg t5) (fluid symval))
       (*move (memory (reg t5) (wconst 0)) (memory (reg t4) (wconst 0)))
       (*move (reg 10) (memory (reg t5) (wconst 0)))
%
%	The eleventh argument
%
       (*jumpnottype (label DONEBINDINGFORMALS) (reg t2) pair-tag)
       (*wplus2 (reg t4) (wconst 8))
       (*jumpwgeq (label BINDINGOVERFLOW) (reg t4) (reg t3))
       (*move (car (reg t2)) (reg t5))
       (*move (cdr (reg t2)) (reg t2))
       (*field (reg t5) (reg t5) 5 27)	% (reg t5) <- id number
       (*move (reg t5) (memory (reg t4) (wconst -4)))
       (*wshift (reg t5) 2)
       (*wplus2 (reg t5) (fluid symval))
       (*move (memory (reg t5) (wconst 0)) (memory (reg t4) (wconst 0)))
       (*move (reg 11) (memory (reg t5) (wconst 0)))
%
%	The twelveth argument
%
       (*jumpnottype (label DONEBINDINGFORMALS) (reg t2) pair-tag)
       (*wplus2 (reg t4) (wconst 8))
       (*jumpwgeq (label BINDINGOVERFLOW) (reg t4) (reg t3))
       (*move (car (reg t2)) (reg t5))
       (*move (cdr (reg t2)) (reg t2))
       (*field (reg t5) (reg t5) 5 27)	% (reg t5) <- id number
       (*move (reg t5) (memory (reg t4) (wconst -4)))
       (*wshift (reg t5) 2)
       (*wplus2 (reg t5) (fluid symval))
       (*move (memory (reg t5) (wconst 0)) (memory (reg t4) (wconst 0)))
       (*move (reg 12) (memory (reg t5) (wconst 0)))
%
%	The thirteenth argument
%
       (*jumpnottype (label DONEBINDINGFORMALS) (reg t2) pair-tag)
       (*wplus2 (reg t4) (wconst 8))
       (*jumpwgeq (label BINDINGOVERFLOW) (reg t4) (reg t3))
       (*move (car (reg t2)) (reg t5))
       (*move (cdr (reg t2)) (reg t2))
       (*field (reg t5) (reg t5) 5 27)	% (reg t5) <- id number
       (*move (reg t5) (memory (reg t4) (wconst -4)))
       (*wshift (reg t5) 2)
       (*wplus2 (reg t5) (fluid symval))
       (*move (memory (reg t5) (wconst 0)) (memory (reg t4) (wconst 0)))
       (*move (reg 13) (memory (reg t5) (wconst 0)))
%
%	The fourteenth argument
%
       (*jumpnottype (label DONEBINDINGFORMALS) (reg t2) pair-tag)
       (*wplus2 (reg t4) (wconst 8))
       (*jumpwgeq (label BINDINGOVERFLOW) (reg t4) (reg t3))
       (*move (car (reg t2)) (reg t5))
       (*move (cdr (reg t2)) (reg t2))
       (*field (reg t5) (reg t5) 5 27)	% (reg t5) <- id number
       (*move (reg t5) (memory (reg t4) (wconst -4)))
       (*wshift (reg t5) 2)
       (*wplus2 (reg t5) (fluid symval))
       (*move (memory (reg t5) (wconst 0)) (memory (reg t4) (wconst 0)))
       (*move (reg 14) (memory (reg t5) (wconst 0)))
%
%	The fifteenth argument
%
       (*jumpnottype (label DONEBINDINGFORMALS) (reg t2) pair-tag)
       (*wplus2 (reg t4) (wconst 8))
       (*jumpwgeq (label BINDINGOVERFLOW) (reg t4) (reg t3))
       (*move (car (reg t2)) (reg t5))
       (*move (cdr (reg t2)) (reg t2))
       (*field (reg t5) (reg t5) 5 27)	% (reg t5) <- id number
       (*move (reg t5) (memory (reg t4) (wconst -4)))
       (*wshift (reg t5) 2)
       (*wplus2 (reg t5) (fluid symval))
       (*move (memory (reg t5) (wconst 0)) (memory (reg t4) (wconst 0)))
       (*move (reg 15) (memory (reg t5) (wconst 0)))
%
%	The sixteenth argument
%
       (*jumpnottype (label DONEBINDINGFORMALS) (reg t2) pair-tag)
       (*wplus2 (reg t4) (wconst 8))
       (*jumpwgeq (label BINDINGOVERFLOW) (reg t4) (reg t3))
       (*move (car (reg t2)) (reg t5))
       (*move (cdr (reg t2)) (reg t2))
       (*field (reg t5) (reg t5) 5 27)	% (reg t5) <- id number
       (*move (reg t5) (memory (reg t4) (wconst -4)))
       (*wshift (reg t5) 2)
       (*wplus2 (reg t5) (fluid symval))
       (*move (memory (reg t5) (wconst 0)) (memory (reg t4) (wconst 0)))
       (*move (reg 16) (memory (reg t5) (wconst 0)))

       (*move '"Too many arguments to function" (reg 1))
       (*jcall stderror)


xxxBINDINGOVERFLOW
       (*jcall bstackoverflow)             % then error

xxxDONEBINDINGFORMALS
       (*move (reg t4) (fluid bndstkptr))   % store binding stack
       (*move (reg t1) (reg 1))             % get cddr of lambda form to eval
       (*call evprogn)                      % implicit progn
       (*move (frame 1) (reg t1))
       (*move (reg 1) (frame 1))            % save result, get old bind stk ptr
       (*move (reg t1) (reg 1))
       (*call restoreenvironment)
       (*move (deferred (reg st)) (reg 1))
       (*wplus2 (reg st) (wconst 8))              % throw away backtrace mark
       (*exit 0)                                  % and return

xxxPROPNOTFOUND
       (*move '"*LAMBDALINK property not found for interpreted function"
              (reg 1))
       (*jcall stderror)))

            
(de lambdaapply (fn args)
  % Fn is Lambda, unevaled Args
  (if (not (and (pairp fn) (weq (car fn) 'lambda)))
    (continuableerror '1104 '"Ill-formed function expression"
                      (cons fn (foreach x in args collect (mkquote x))))
    (prog (formals n result)
          (setq formals (cadr fn))
          (setq n 0)
          (while (and (pairp formals) (pairp args))
            (lbind1 (car formals) (car args))
            (setq formals (cdr formals))
            (setq args (cdr args))
            (setq n (wplus2 n 1)))
          (when (or (pairp formals) (pairp args))
            (return (continuableerror '1204 '"Argument number mismatch"
                     (cons fn (foreach x in args collect (mkquote x))))))
          (setq result (evprogn (cddr fn)))
          (when (wneq n 0)
            (unbindn n))
          (return result))))

(lap '((*entry list5 expr 5)
	(*move ($fluid heaplast)      (reg o3))
	(*move ($fluid heaptrapbound) (reg o4))
	(sethi 16#120000 (reg o2))         % pair-tag
	(or (reg o3) (reg o2) (reg o1))   % the result
	(add (reg o1) 8 (reg o2))         % first pair
	(st (reg 1)  (indexed (reg o3) 0))
	(st (reg o2) (indexed (reg o3) 4))
	(add (reg o1) 16 (reg o2))         % second pair
	(st (reg 2)  (indexed (reg o3) 8))
	(st (reg o2) (indexed (reg o3) 12))
	(add (reg o1) 24 (reg o2))         % third pair
	(st (reg 3)  (indexed (reg o3) 16))
	(st (reg o2) (indexed (reg o3) 20))
	(add (reg o1) 32 (reg o2))         % fourth pair
	(st (reg 4)  (indexed (reg o3) 24))
	(st (reg o2) (indexed (reg o3) 28))
	(st (reg 5)  (indexed (reg o3) 32))
	(st (reg NIL)(indexed (reg o3) 36))
        (add (reg o3) 40 (reg o3))         % fifth pair
	(subcc (reg o3) (reg o4) (reg g0))
	(bl enough)
	(*move (reg o3) ($fluid heaplast)) 
        (*alloc 1) 
        (*move (reg i1) (frame 1))
        (*link !%reclaim expr 0) 
        (*move (frame 1) (reg i1))  % Restore Result; all other Regs are not of
        (*dealloc 1)                % interest any more 
  
    enough
	(jmpl (displacement (reg o7) 8) (reg g0))
	(*move (reg o1) (reg 1)) 
)   )

(lap '((*entry list4 expr 4)
        (*move ($fluid heaplast)      (reg o3))
        (*move ($fluid heaptrapbound) (reg o4))
	(sethi 16#120000 (reg o2))         % pair-tag
	(or (reg o3) (reg o2) (reg o1))   % the result
	(add (reg o1) 8 (reg o2))         % first pair
	(st (reg 1)  (indexed (reg o3) 0))
	(st (reg o2) (indexed (reg o3) 4))
	(add (reg o1) 16 (reg o2))         % second pair
	(st (reg 2)  (indexed (reg o3) 8))
	(st (reg o2) (indexed (reg o3) 12))
	(add (reg o1) 24 (reg o2))         % third pair
	(st (reg 3)  (indexed (reg o3) 16))
	(st (reg o2) (indexed (reg o3) 20))
	(st (reg 4)  (indexed (reg o3) 24))
	(st (reg NIL)(indexed (reg o3) 28))
        (add (reg o3) 32 (reg o3))         % fourth pair
	(subcc (reg o3) (reg o4) (reg g0))
	(bl enough)
	(*move (reg o3) ($fluid heaplast)) 
        (*alloc 1) 
        (*move (reg i1) (frame 1))
        (*link !%reclaim expr 0) 
        (*move (frame 1) (reg i1))  % Restore Result; all other Regs are not of
        (*dealloc 1)                % interest any more 
  
    enough
	(jmpl (displacement (reg o7) 8) (reg g0))
	(*move (reg o1) (reg 1)) 
)   )

(lap '((*entry list3 expr 3)
        (*move ($fluid heaplast)      (reg o3))
        (*move ($fluid heaptrapbound) (reg o4))
	(sethi 16#120000 (reg o2))         % pair-tag
	(or (reg o3) (reg o2) (reg o1))   % the result
	(add (reg o1) 8 (reg o2))         % first pair
	(st (reg 1)  (indexed (reg o3) 0))
	(st (reg o2) (indexed (reg o3) 4))
	(add (reg o1) 16 (reg o2))         % second pair
	(st (reg 2)  (indexed (reg o3) 8))
	(st (reg o2) (indexed (reg o3) 12))
	(st (reg 3)  (indexed (reg o3) 16))
	(st (reg NIL)(indexed (reg o3) 20))
        (add (reg o3) 24 (reg o3))         % third pair
	(subcc (reg o3) (reg o4) (reg g0))
	(bl enough)
	(*move (reg o3) ($fluid heaplast)) 
        (*alloc 1)
        (*move (reg i1) (frame 1))
        (*link !%reclaim expr 0)
        (*move (frame 1) (reg i1))  % Restore Result; all other Regs are not of
        (*dealloc 1)                % interest any more
 
    enough
	(jmpl (displacement (reg o7) 8) (reg g0))
	(*move (reg o1) (reg 1)) 
)   )

(lap '((*entry list2 expr 2)
        (*move ($fluid heaplast)      (reg o3)) 
        (*move ($fluid heaptrapbound) (reg o4)) 
        (sethi 16#120000 (reg o2))     
	(or (reg o3) (reg o2) (reg o1))   % the result
	(add (reg o1) 8 (reg o2))         % first pair
	(st (reg 1)  (indexed (reg o3) 0))
	(st (reg o2) (indexed (reg o3) 4))
	(st (reg 2)  (indexed (reg o3) 8))
	(st (reg NIL)(indexed (reg o3) 12))
        (add (reg o3) 16 (reg o3))         % second pair
	(subcc (reg o3) (reg o4) (reg g0))
	(bl enough)
	(*move (reg o3) ($fluid heaplast)) 
	(*alloc 1)
	(*move (reg i1) (frame 1))
	(*link !%reclaim expr 0)
	(*move (frame 1) (reg i1))  % Restore Result; all other Regs are not of
	(*dealloc 1)                % interest any more

    enough
	(jmpl (displacement (reg o7) 8) (reg g0))
	(*move (reg o1) (reg 1)) 
))
