%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:    APPLY-LAP - efficient, Cray-specific version of APPLY-LAP
%
% Author:  H. Melenk and W. Neun
%          Konrad-Zuse-Zentrum fuer Informationstechnik
%                Berlin
% Date:    25 June 1986
%
% Copyright (c) Konrad Zuse - Zentrum Berlin , all rights reserved
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 % CodePrimitive
 %      Takes the code pointer stored in the fluid variable CodePtr*
 %      and jumps to its address, without distubing any of the argument
 %      registers.  This can be flagged 'InternalFunction for compilation
 %      before this file is compiled or done as an 'OpenCode and 'ExitOpenCode
 %      property for the compiler.
 % CompiledCallingInterpreted
 %      Called by some convention from the function cell of an ID which
 %      has an interpreted function definition.  It should store the ID
 %      in the fluid variable CodeForm* without disturbing the argument
 %      registers, then finish with
 %      (*JCALL CompiledCallingInterpretedAux)
 %      (CompiledCallingInterpretedAux may be flagged 'InternalFunction).
 % FastApply
 %      Called with a functional form in (reg t1) and argument registers
 %      loaded.  If it is a code pointer or an ID, the function address
 %      associated with either should be jumped to.  If it is anything else
 %      except a lambda form, an error should be signaled.  If it is a lambda
 %      form, store (reg t1) in the fluid variable CodeForm* and
 %      (*JCALL FastLambdaApply)
 %      (FastLambdaApply may be flagged 'InternalFunction).
 % UndefinedFunction
 %      Called by some convention from the function cell of an ID (probably
 %      the same as CompiledCallingInterpreted) for an undefined function.
 %      Should call Error with the ID as part of the error message.
 
(COMPILETIME
(progn   (fluid '(codeargs codeptr* codeform*))
         (flag '(compiledcallinginterpretedauxaux
                 bindevalaux ) 'internalfunction)
         (load vector-instructions if-system)
 
(put  'opencodeprimitive 'exitopencode
    '((*move (reg 2) (Reg A6))
      (*MOVE (Reg 3) (reg S7))
      (*move (indexed (reg a6) 4) (Reg 5))
      (*move (indexed (reg a6) 3) (Reg 4))
      (*move (indexed (reg a6) 2) (Reg 3))
      (*move (indexed (reg a6) 1) (Reg 2))
      (*move (reg Nargreg) (reg s6))
      (*wrshift (reg S6) 4)
      (*wlshift (reg s6) 4)
      (*wor (reg S6) (Reg 1))
      (*move (indexed (reg a6) 0) (Reg 1))
      (*move (reg s6) (reg Nargreg))
      (*JUMP (memory (Reg S7) (wconst 0)))
)    )
 
(put  'opencodeprimitive 'opencode
    '((*move (reg 2) (Reg A6))
      (*Wshift (Reg 3) 2)
      (*MOVE (Reg 3) (reg a1))
      (*move (indexed (reg a6) 4) (Reg 5))
      (*move (indexed (reg a6) 3) (Reg 4))
      (*move (indexed (reg a6) 2) (Reg 3))
      (*move (indexed (reg a6) 1) (Reg 2))
      (*move (reg Nargreg) (reg s6))
      (*wrshift (reg S6) 4)
      (*wlshift (reg s6) 4)
      (*wor (reg S6) (Reg 1))
      (*move (indexed (reg a6) 0) (Reg 1))
      (*move (reg s6) (reg Nargreg))
      (*RetJUMP (Reg a1))
)    )
)) %end compiletime
 
(SETQ CODEARGS (gtwarray 16))
 
(lap '((*entry fast-codeapply expr 2)
       (*move (reg t1) (reg S6))
       (*wshift (reg s6) 2)
       (*move (reg s6) (reg b01))
       (j (reg b01))
)     )
 
(DE CODEAPPLY (CODEPTR ARGLIST)
  (PROG (I)
        (SETQ I 0)
        (WHILE (AND (PAIRP ARGLIST) (wLESSP I 15))
               (PROGN (WPUTV CODEARGS I (FIRST ARGLIST))
                      (SETQ I (wplus2 I 1))
                      (SETQ ARGLIST (REST ARGLIST))))
        (COND ((pairp Arglist)
               (RETURN (STDERROR (LIST "Too many arguments to function" I
                                       CODEPTR)))))
        (when (wgreaterp i 5)
                (vsetvl (wdifference i 5))
                (vload (vreg 1) (wplus2 codeargs 5) 1)
                (vstore (vreg 1) argumentblock 1))
        (return (opencodeprimitive i CODEARGS codeptr))
))
 
 
 %lisp procedure CodeEvalApply(CodePtr, ArgList);
 %    CodeApply(CodePtr, EvLis ArgList);
 
(if_system Cray1
(Lap '((*Entry CodeEvalApply expr 3)
       (*ALLOC 20)
       (*MOVE 0 (reg t30))                 % n in t30
       (*MOVE (reg 1) (reg t31))           % codeptr in t31
       (*mkitem (Reg 3) btr-tag)
       (*move (Reg 3) (frame 19))
 
       (*move (reg 2) (reg a5))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 1 (reg t30))
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t33))
 
       (*move (reg 2) (reg a5))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 2 (reg t30))
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t34))
 
       (*move (reg 2) (reg a5))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 3 (reg t30))
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t35))
 
       (*move (reg 2) (reg a5))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 4 (reg t30))
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t36))
 
       (*move (reg 2) (reg a5))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 5 (reg t30))
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t37))
 
       (*move (reg 2) (reg a5))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 6 (reg t30))
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t40))
 
       (*move (reg 2) (reg a5))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 7 (reg t30))
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t41))
 
       (*move (reg 2) (reg a5))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 8 (reg t30))
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t42))
 
       (*move (reg 2) (reg a5))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 9 (reg t30))
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t43))
 
       (*move (reg 2) (reg a5))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 10 (reg t30))
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t44))
 
       (*move (reg 2) (reg a5))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 11 (reg t30))
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t45))
 
       (*move (reg 2) (reg a5))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 12 (reg t30))
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t46))
 
       (*move (reg 2) (reg a5))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 13 (reg t30))
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t47))
 
       (*move (reg 2) (reg a5))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 14 (reg t30))
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t50))
 
       (*move (reg 2) (reg a5))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 15 (reg t30))
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t51))
 
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
 
       (*move (quote "Too many arguments to function") (reg 1))
       (*dealloc 20)
       (*jcall stderror expr 1)
 
     nopair1
       (*move (reg t30) (reg s6))
       (*move 5 (reg s7))
       (*move (reg 4) (reg 1))  % to clear pending load operations
       (*move (reg t37) (reg 5))
       (*move (reg t36) (reg 4))
       (*move (reg t35) (reg 3))
       (*move (reg t34) (reg 2))
       (*move (reg t33) (reg 1))
       (*jumpwgreaterp (label extraregs) (reg s6) (reg s7))
       (*move (reg t31) (reg t1))
       (*move (reg Nargreg) (reg s7))
       (*wrshift (reg S7) 4)
       (*wlshift (reg s7) 4)
       (*wor (reg S7) (Reg s6))
       (*move (reg s7) (reg Nargreg))
       (*dealloc 20)
       (*move (reg t1) (reg s7))
       (*JUMP (memory (Reg S7) (wconst 0)))
  extraregs
       (*move (reg argumentblock) (reg a0))
       (*move 10 (reg a1))
       (blksto (reg a1) (reg t40))
       (*move (reg t31) (reg t1))
       (*move (reg Nargreg) (reg s7))
       (*wrshift (reg S7) 4)
       (*wlshift (reg s7) 4)
       (*wor (reg S7) (Reg s6))
       (*move (reg s7) (reg Nargreg))
       (*dealloc 20)
       (*move (reg t1) (reg s7))
       (*JUMP (memory (Reg S7) (wconst 0)))
))
(Lap '((*Entry CodeEvalApply expr 3)
       (*ALLOC 20)
       (DRI)
       (*MOVE 0 (reg t30))                 % n in t30
       (*MOVE (reg 1) (reg t31))           % codeptr in t31
       (*mkitem (Reg 3) btr-tag)
       (*move (Reg 3) (frame 19))
 
       (*move (reg 2) (reg a5))
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 1 (reg t30))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (ERI)
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (DRI)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t33))
 
       (*move (reg 2) (reg a5))
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 2 (reg t30))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (ERI)
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (DRI)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t34))
 
       (*move (reg 2) (reg a5))
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 3 (reg t30))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (ERI)
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (DRI)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t35))
 
       (*move (reg 2) (reg a5))
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 4 (reg t30))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (ERI)
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (DRI)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t36))
 
       (*move (reg 2) (reg a5))
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 5 (reg t30))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (ERI)
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (DRI)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t37))
 
       (*move (reg 2) (reg a5))
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 6 (reg t30))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (ERI)
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (DRI)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t40))
 
       (*move (reg 2) (reg a5))
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 7 (reg t30))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (ERI)
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (DRI)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t41))
 
       (*move (reg 2) (reg a5))
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 8 (reg t30))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (ERI)
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (DRI)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t42))
 
       (*move (reg 2) (reg a5))
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 9 (reg t30))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (ERI)
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (DRI)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t43))
 
       (*move (reg 2) (reg a5))
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 10 (reg t30))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (ERI)
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (DRI)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t44))
 
       (*move (reg 2) (reg a5))
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 11 (reg t30))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (ERI)
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (DRI)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t45))
 
       (*move (reg 2) (reg a5))
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 12 (reg t30))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (ERI)
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (DRI)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t46))
 
       (*move (reg 2) (reg a5))
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 13 (reg t30))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (ERI)
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (DRI)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t47))
 
       (*move (reg 2) (reg a5))
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 14 (reg t30))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (ERI)
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (DRI)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t50))
 
       (*move (reg 2) (reg a5))
       (*move (indexed (reg a5) 1) (reg 4))
       (*move (indexed (reg a5) 0) (reg 1))
       (*MOVE (reg 2) (reg t32))           % arglist in t32
       (*move 15 (reg t30))
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
       (ERI)
       (*move (reg 4) (Reg T52))
       (*call eval expr 1)
       (DRI)
       (*move (Reg T52) (reg 2))
       (*move (reg 1) (reg t51))
 
       (*JumpNotType (label nopair1) (reg 2) pair-tag)
 
       (*move (quote "Too many arguments to function") (reg 1))
       (*dealloc 20)
       (*jcall stderror expr 1)
 
     nopair1
       (*move (reg t30) (reg s6))
       (*move 5 (reg s7))
       (*move (reg 4) (reg 1))  % to clear pending load operations
       (ERI)
       (*move (reg t37) (reg 5))
       (*move (reg t36) (reg 4))
       (*move (reg t35) (reg 3))
       (*move (reg t34) (reg 2))
       (*move (reg t33) (reg 1))
       (*jumpwgreaterp (label extraregs) (reg s6) (reg s7))
       (*move (reg t31) (reg t1))
       (*move (reg Nargreg) (reg s7))
       (*wrshift (reg S7) 4)
       (*wlshift (reg s7) 4)
       (*wor (reg S7) (Reg s6))
       (*move (reg s7) (reg Nargreg))
       (*dealloc 20)
       (*move (reg t1) (reg s7))
       (*JUMP (memory (Reg S7) (wconst 0)))
  extraregs
       (*move (reg argumentblock) (reg a0))
       (*move 10 (reg a1))
       (blksto (reg a1) (reg t40))
       (*move (reg t31) (reg t1))
       (*move (reg Nargreg) (reg s7))
       (*wrshift (reg S7) 4)
       (*wlshift (reg s7) 4)
       (*wor (reg S7) (Reg s6))
       (*move (reg s7) (reg Nargreg))
       (*dealloc 20)
       (*move (reg t1) (reg s7))
       (*JUMP (memory (Reg S7) (wconst 0)))
)))
(commentoutcode
(DE CODEEVALAPPLYAUX (CODEPTR ARGLIST P)
  (PROG (N)
        (SETQ N 0)
        (WHILE (AND (PAIRP ARGLIST) (wlESSP N 15))
               (PROGN (WPUTV P  N (EVAL (FIRST ARGLIST)))
                      (SETQ ARGLIST (REST ARGLIST))
                      (SETQ N (wplus2 N 1))))
        (COND ((pairp arglist)
               (RETURN (STDERROR "Too many arguments to function"))))
        (when (wgreaterp n 5)
                (vsetvl (Wdifference n 5))
                (vload (vreg 1) (wplus2 p 5) 1)
                (vstore (vreg 1) argumentblock 1))
        (return (opencodeprimitive n p codeptr))
) )
)
 
(DE BINDEVAL (FORMALS ARGS)
  (BINDEVALAUX FORMALS ARGS 0))
 
(DE BINDEVALAUX (FORMALS ARGS N)
  (PROG (F A)
        (RETURN (COND ((PAIRP FORMALS)
                       (COND ((PAIRP ARGS)
                              (PROGN (SETQ F (FIRST FORMALS))
                                     (SETQ A (EVAL (FIRST ARGS)))
                                     (SETQ N
                                      (BINDEVALAUX (REST FORMALS)
                                       (REST ARGS) (WPLUS2 N 1)))
                                     (COND ((WEQ N -1) -1)
                                           (T (PROGN (LBIND1 F A)
                                                     N)))))
                             (T -1)))
                      ((PAIRP ARGS) -1)
                      (T N)))))
 
(DE COMPILEDCALLINGINTERPRETEDAUX NIL
  (PROGN (COMPILEDCALLINGINTERPRETEDAUXAUX
          (GET (MKID CODEFORM*) '*LAMBDALINK))))
 
(DE FASTLAMBDAAPPLY NIL
  (PROGN (SAVEREGISTERS)
         (COMPILEDCALLINGINTERPRETEDAUXAUX CODEFORM*)))
 
(DE COMPILEDCALLINGINTERPRETEDAUXAUX (FN)
  (COND ((NOT (eqcar FN 'LAMBDA))
         (STDERROR (BLDMSG "Ill-formed functional expression %r for %r" FN
                           CODEFORM*)))
        (T (PROG (FORMALS N RESULT)
                 (SETQ FORMALS (CADR FN))
                 (SETQ N 0)
                 (WHILE (PAIRP FORMALS)
                        (PROGN (LBIND1 (CAR FORMALS) (WGETV CODEARGS N))
                               (SETQ FORMALS (CDR FORMALS))
                               (SETQ N (wplus2 N 1))))
                 (SETQ RESULT (EVPROGN (CDDR FN)))
                 (COND ((WNEQ N 0) (UNBINDN N)))
                 (RETURN RESULT)))))
