%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PNK:DEFCONST.SL 
% Title:        Definition and use of symbolic constants 
% Author:       Eric Benson 
% Created:      8 January 1982 
% Modified:     01-Dec-83 14:28:04 
% Status:       Experimental 
% Mode:         Lisp 
% Package:      Kernel 
% Compiletime:  
% Runtime:      
%
% (c) Copyright 1983, Hewlett-Packard Company, all rights reserved.
% (c) Copyright 1982, University of Utah
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 01-Dec-83 14:28:04 (Brian Beach)
%   Translated from Rlisp to Lisp.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                          
% DefConst is used to define a value for a name, to be used in const(Name) 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(dm defconst (form)
  %. DefConst(Name, Value, ...);                                           
  (prog (resultform)
        (setq resultform (list 'progn))
        (setq form (cdr form))
        (while (not (null form))
          (setq resultform 
                (cons (list 'evdefconst (mkquote (car form)) 
                       (mkquote (cadr form)))
                      resultform))
          (setq form (cddr form)))
        (return (reversip resultform))))

(flag '(defconst) 'eval)

(de evdefconst (constname constvalue)
  (put constname 'const constvalue))

(dm const (form)
  (or (get (cadr form) 'const) 
      (stderror (bldmsg "Unknown const form %r" form))))

