%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PNK:PUTD-GETD.SL 
% Title:        Standard Lisp function defining functions 
% Author:       Eric Benson 
% Created:      18 August 1981 
% Modified:     22-Mar-84 11:53:01 (Brian Beach) 
% Status:       Experimental 
% Mode:         Lisp 
% Package:      Kernel 
% Compiletime:  
% Runtime:      
%
% (c) Copyright 1983, Hewlett-Packard Company, all rights reserved.
% (c) Copyright 1981, University of Utah
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 01-Dec-83 14:59:44 (Brian Beach)
%   Translated from Rlisp to Lisp.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(de getd (u)
  % Lookup function definition of U
  (and (idp u) (not (funboundp u))
       (cons (or (get u 'type) 'expr) (if (flambdalinkp u)
               (get u '*lambdalink)
               (getfcodepointer u)))))

(de remd (u)
  % Remove function definition of U
  (prog (oldgetd)
        (when (setq oldgetd (getd u))
          (makefunbound u)
          (remprop u 'type)
          (remprop u '*lambdalink))
        (return oldgetd)))

(fluid '(*redefmsg % controls printing of redefined

                   *usermode))

% controls query for redefinition
(loadtime
  (progn (setq *usermode nil)
         % start in system mode
         (setq *redefmsg t)))

% message in PutD
(fluid '(*comp % controls automatic compilation
	 promptstring*))

