%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:           PU:QUALIFIED-COUNTING.SL
% Description:    counting function execution with callers ref.
% Author:         Herbert Melenk and Winfried Neun, ZIB Berlin
% Created:        5 September 1986
% Status:         Experimental (Do Not Distribute), CRAY version only
% Mode:           Lisp
% Package:        Utilities
%
% Copyright (c) 1987, Konrad Zuse Zentrum Berlin, all rights reserved
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
(cond ((not (getd 'priv-assoc)) (copyd 'priv-assoc 'assoc)))
(cond ((not (getd 'priv-get))   (copyd 'priv-get 'get)))
(cond ((not (getd 'priv-put))   (copyd 'priv-put 'put)))
 
(imports '(compiler))
 
(on comp)
 
(dm qualcount (u)
  (let ((name (intern (gensym)))(name2 (intern (gensym))))
  (setq u (cadr u))
   `(progn
       (copyd ',name ',u)
       (de ,name2 (x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 x15)
          (prog (retadr countpos)
           (setq retadr (quallap))
           (setq countpos (priv-assoc retadr (priv-get ',u 'qualcount)))
           (cond (countpos
                    (rplacd countpos (wplus2 1 (cdr countpos))))
                 (t (priv-put ',u 'qualcount
                         (cons (cons retadr 1)
                            (priv-get ',u 'qualcount)))))
           (return (,name x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13
                       x14 x15))
        )  )
        (compile (list ',name2))
        (copyd ',u ',name2)
) )  )
 
(put 'quallap 'opencode '((*move (reg b00) (reg 1))))
 
(fluid '(*bordervalue*))
 
(setq *bordervalue* 20)
 
(df print-qualcount (u)
    (prog (x)
      (setq u (car u))
      (prin2 "************* calls for function ")
      (prin2  u)
      (prin2t " ************* ")
      (setq x (priv-get u 'qualcount))
   aa
      (terpri)
      (when ( null x) (return nil))
      (when (wgreaterp (cdar x) *bordervalue*)
        (prin2 "number of calls : ") (prin2 (cdar x))
        (prin2t "  from")
        (map-at (wrshift (caar x) 2)))
      (setq x (cdr x))
      (go aa)
)   )
 
(de reset-qualcount() (mapobl (function (lambda (x)
                                           (remprop x 'qualcount)))))
 
(prin2t "use (qualcount function), (print-qualcount function)")
(prin2t "and (reset-qualcount)")
(prin2t "use *bordervalue* as level for printing")
