%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:           read-hmc.sl
% Title:          read and print machine characteristics for Cray X/Y
% Author:         Winfried Neun , ZIB Berlin
% Created:        12 September 1988
% Status:         Experimental
% Mode:           Lisp
%
% (c) Copyright 1988  Konrad Zuse-Zentrum Berlin
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Usage: (read-hmc nil)  prints hardwre information.
%        (read-hmc <int>) returns specific hardware information
%                         seee  gethmc description in COS or UNICOS
 
(ds logival (x) (if (eq x 0) "No" "Yes"))
 
(ds prin2lt (x) (prin2l x) (terpri))
 
(de read-hmc(value-cell)
 (prog (aa)
   (setq aa (machine-characteristics))
   (return
   (if (posintp value-cell) (wgetv aa (wplus2 value-cell 1))
       (prin2t " *** Machine characteristics ")
       (terpri)
       (prin2l  (list " **** Name ****  " ))
          (for (from i 0 7 1) (do (writechar (strbyt aa i))))
       (terpri)
       (prin2lt (list "  Memory banks : " (wgetv aa 2)))
       (prin2lt (list "  Processors   : " (wgetv aa 3)))
       (prin2lt (list "  InstBuffer /w: " (wgetv aa 4)))
       (prin2lt (list "  Main Memory  : " (wgetv aa 5)))
       (prin2lt (list "  clocks/Memory: " (wgetv aa 6)))
       (prin2lt (list "  clock /picos : " (wgetv aa 7)))
       (prin2lt (list "  Clusters     : " (wgetv aa 8)))
       (prin2lt (list "  Memory busy  : " (wgetv aa 9)))
       (prin2lt (list "  EMA          : " (logival (wgetv aa 65))))
       (prin2lt (list "  CInd ScatGath: " (logival (wgetv aa 66))))
       (prin2lt (list "  VPopcount    : " (logival (wgetv aa 67))))
       (prin2lt (list "  Prog Clock   : " (logival (wgetv aa 68))))
       (prin2lt (list "  VL be read   : " (logival (wgetv aa 69))))
       (prin2lt (list "  No Vec recur : " (logival (wgetv aa 70))))
       (prin2lt (list "  Add Vec Logic: " (logival (wgetv aa 71))))
       (prin2lt (list "  Hdw Perfmon  : " (logival (wgetv aa 72))))
       (prin2lt (list "  Bidirect Mem : " (logival (wgetv aa 73))))
       (prin2lt (list "  Status reg   : " (logival (wgetv aa 74))))
       (prin2lt (list "  DRI / ERI    : " (logival (wgetv aa 75))))
       NIL)
)  ))
 
