%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PU:USEFUL.SL 
% Description:  Load a lot of "useful" packages. 
% Author:       Nancy Kendzierski 
% Created:      11-Jan-84 
% Modified:     7 May 1984 1056-PDT (Nancy Kendzierski) 
% Package:      
%
% (c) Copyright 1987, University of Utah, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 6 May 1984 1619-PDT (Nancy Kendzierski)
%  Changed the file to load separately compiled modules, instead of dskin
%  source files to create one indivisible binary.  Added CHAR-MACRO to the
%  modules in USEFUL (formerly in the "kernel", i.e. bare-psl).  Changed
%  name of destructure files to defmacro.
% 26 Jan 1984 1604-PST (Brian Beach)
%  Corrected file name in header.
% 11 Jan 1984 2012-PST (Nancy Kendzierski)
%  Created this file to replace useful.build
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% NOTE:  The modules in USEFUL are structured so that they can be compiled
% (bootstapped) in the following order:
%
%   backquote, read1macros, char-macro, read2macros, read-macro,
%   defmacro1, defmacro2, defmacro, cond-macros, bind-macros,
%   set1-macros, set2-macros, set-macros, iter-macros, for-macro,
%   misc-macros, macroexpand, useful
%
% Modules with many parts (e.g. read1-macros, read2-macros, read-macros)
% were split into pieces because the second part required the first to
% already be compiled and loaded in order to compile itself.  The third
% part is merely a module to load both halves (so a user doesn't need to
% know the structure).
%
% NOTE:  Modules in USEFUL should not use the features in USEFUL, unless
% the feature is defined in a "previous" module, where "previous" is
% determined by compilation order.  This ensures that the module USEFUL
% can be rebuilt "from scratch".
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(load   backquot charmacr read1mac read2mac defmacr1 defmacr2 condmacr
        bindmacr set1macr set2macr itermacr formacr miscmacr macroexp)

% End of file.
